<!DOCTYPE html>
<html>
	<head>
		<title>Inverse</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var aggregate = function(arr, seed, func) {
				var accumulate = seed;
				for(var i = 0; i < arr.length; i++)
					accumulate = func(accumulate, arr[i]);
				return accumulate;
			}
			var AddFormula = function(container, name, tex) {
				var containerSelector = $('#' + container);
				if ($('#' + name).length == 0)
					containerSelector.append("<div id='" + name + "' style='text-align:left; visibility: visible; padding:10;'>");
				else $('#' + name).html("");

				$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
				MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			}
			var ReadMatrix = function(text) {
				
				var data = [];
				text = text.replace( /\s\s+/g, ' ' );
				var lines = text.split(/\r|\n/);
				for (var i = 0; i < lines.length; i++) {
					var lineData = [];
					var cells = lines[i].split(' ');
					for (var j = 0; j < cells.length; j++) {
						if(cells[j] != "") {
							lineData.push(parseInt(cells[j]));
						}
					}
					if (lineData.length > 0)
						data.push(lineData);
				}
				return data;
			}
		</script>
	</head>

	<body>
		
		<table>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>Mod</b></label> </td> 
			<td> <input type="text" id="txtMod" value="10"/> </td>
		</tr>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>Val</b></label> </td> 
			<td> <input type="text" id="txtVal" value=""/> </td>
		</tr>
		<tr>
			<td> </td> 
			<td> <input type="checkbox" id="chkHide" checked/> $EBOB(m,a) \ne 1$ olanları gizle.</td>
		</tr>
		<tr>
			<td> </td> 
			<td> <input type="checkbox" id="chkSkip" value="false"/> Sadece yolu yaz.</td>
		</tr>
		<tr>
			<td> </td> 
			<td> <input type="button" id="btnCalc" value="Hesapla" /> </td>
		</tr>
		</table>

		<div id="divResult"></div>
		
		
		
		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnCalc") {

					
						var isRelativelyPrime = function(a,b){
							var min = Math.min(a,b)+1;
							for (var i = 2; i < min; i++){
								if (a % i == 0 && b % i == 0)
									return false;
							}
							return true;
						}
					
						var m = parseInt($('#txtMod').val());
						var v = parseInt($('#txtVal').val());
						var hide = $('#chkHide')[0].checked;
						var skip = $('#chkSkip')[0].checked;
						
						$("#divResult").html("");
						$("#divResult").append("<table id = 'tbl'></table>");
						$("#tbl").append("<tr id='tr_1'></tr>");
						var i = 2;
						var l = m;
						if (!isNaN(v)) {
							i = v;
							l = v+1;
						}
						for (i; i < l; i++){
							var isRelPrime = isRelativelyPrime(m, i);
							if (hide && !isRelPrime) 
								continue;
								
							var arr = {};
							$("#tr_1").append("<td align='right' style='vertical-align: top;padding-right:50px' id = 'td_" + i + "'></td>");
							var txt = "";
							for (var j = 1; j < m; j++) {
								var r = ((i*j) % m);
								txt = i + "*" + j + "=" + r;
								if (r == 0) txt = "\\color{red}{" + txt + "}";
								if (r == 1) txt = "\\color{black}{" + txt + "}";
								txt = "\\color{gray}{" + txt + "}";
								if (!skip)
									AddFormula("td_" + i, "MathOutputInfo" + (i*m+j), txt);
								
								if (isRelPrime)
									arr[r] = j;
							}
							console.log(arr);
							if (isRelPrime){
								var val = 1;
								var prev = -1;
								var c = 0;
								while(true) {
									prev = val;
									val = arr[val];
									console.log(val);
									c++;
									AddFormula("td_" + i, "MathOutputInfo"+Math.random().toString().replace('.', ''), val);
									if (val == 1 || val == m-1 || val == prev)
										break;
								}
								AddFormula("td_" + i, "MathOutputInfo"+Math.random().toString().replace('.', ''), "C:" + c);
							}
						}
						
						return;
					}
				});
			});
		</script>

	</body>
</html>
